<?php
/*
Plugin Name: Event Calendar Countdown Widget
Plugin URI: http://www.metma.ch/home/archives/443
Description: Adds sidebar CountdownWidget for Event Calendar 3.1.4 and Upcoming Events. Requires the <a href="http://wpcal.firetree.net/">EventCalendar</a> plugin (Version 3.1 and later). 
Author: Marc Metzger
Version: 1
Author URI: http://www.metma.ch


*/

/*
Copyright (c) 2009, Marc Metzger  $1
			 


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

function ec3_widget_countd_init() 
{

  if ( !function_exists('register_sidebar_widget') )
    return;

  /** Utility function: Gets the (possibly translated) widget title, given the
   *  value of the 'title' option. */
  function ec3_widget_countd_title($title,$default)
  {
    if ( empty($title) )
        return __($default,'ec3');
    else
        return apply_filters('widget_title',$title);
  }


/** New the Countdown by Metma */
define('EC3_DEFAULT_TEMPLATE_COUNTD','<a href="%LINK%">%TITLE% </a>');
define('EC3_DATE_FORMAT_HOVER',   'l, j. F Y, H:i');
function ec3_get_countd_events(
  $limit,
  $template_event=EC3_DEFAULT_TEMPLATE_COUNTD,
  $template_day  =EC3_DEFAULT_TEMPLATE_DAY,
  $date_format   =EC3_DEFAULT_DATE_FORMAT,
  $template_month=EC3_DEFAULT_TEMPLATE_MONTH,
  $month_format  =EC3_DEFAULT_MONTH_FORMAT,
  $hover_format  =EC3_DATE_FORMAT_HOVER)
{
  if(!ec3_check_installed(__('Countdown Events','ec3')))
    return;
  global $ec3,$wpdb,$wp_version;

  // Parse $limit:
  //  NUMBER      - limits number of posts
  //  NUMBER days - next NUMBER of days
  if(empty($limit))
  {
    $limit_numposts='LIMIT 5';
  }
  elseif(preg_match('/^ *([0-9]+) *d(ays?)?/',$limit,$matches))
  {
    $secs=intval($matches[1])*24*3600;
    $and_before="AND start<='".ec3_strftime('%Y-%m-%d',time()+$secs)."'";
  }
  elseif(intval($limit)<1)
  {
    $limit_numposts='LIMIT 5';
  }
  else
  {
    $limit_numposts='LIMIT '.intval($limit);
  }

  if(!$date_format)
      $date_format=get_settings('date_format');
  // Find the upcoming events.
  $calendar_entries = $wpdb->get_results(
    "SELECT DISTINCT
       p.id AS id,
       post_title,
       start,
       end,
       u.$ec3->wp_user_nicename AS author,
       allday
     FROM $ec3->schedule s
     LEFT JOIN $wpdb->posts p ON s.post_id=p.id
     LEFT JOIN $wpdb->users u ON p.post_author = u.id
     WHERE p.post_status='publish'
       AND end>='$ec3->today' $and_before
     ORDER BY start $limit_numposts"
  );


   echo "<ul class='ec3_events'>";
  echo "<!-- New Widget from Metma for Eventcalendar 3-->\n";
  if($calendar_entries)
  {
    $time_format=get_settings('time_format');
    $data=array();
    foreach($calendar_entries as $entry)
    {

      if($entry->allday)
          $data['TIME']=__('all day','ec3');
      else
          $data['TIME']=mysql2date($time_format,$entry->start);


      $data['TITLE'] =$entry->post_title;
      $data['LINK']  =get_permalink($entry->id);
      $data['AUTHOR']=$entry->author;



// convert to a timestamp
$when = split("[/: .-]", $entry->start);
$cur = date("m/d/Y/H/i");
$date = mktime($when[3],$when[4],$when[5],$when[1],$when[2],$when[0]);
$now = time();
$diff= $date - $now;
$days = floor($diff / (60*60*24));
$hours = floor($diff / (60*60));
$minutes = floor($diff / (60));
$whenE = split("[/: .-]", $entry->end);
$dateEnd = mktime($whenE[3],$whenE[4],$whenE[5],$whenE[1],$whenE[2],$whenE[0]);
$diffEnd= $dateEnd - $now;
$daysEnd = floor($diffEnd / (60*60*24));
$minutesEnd = floor($diffEnd / (60));
$event=ec3_format_str($template_event ,$data);

// echo " <li>".$days."</li>\n";
// echo " <li>".$daysEnd."</li>\n";


$dc_datedisplay=mysql2date($hover_format,$entry->start);

// Output only, if endminuts is positiv
if ($minutesEnd > 0)
{
print  "<li class='ec3_list ec3_list_day' ";
// display hover of actual date
print "title='$dc_datedisplay '>";
// show the number of days left
if ($minutes < 0 && $daysEnd >= 0) {
// Event findet statt
print "Im Moment: $event</li>";
}
elseif ($days == 0 && $hours > 0) {
// wieviel Stunden bis zum Termin
if ($hours == 1) {
	print "<strong>$hours</strong> Stunde bis: $event</li>";
	}
	else {
	print "<strong>$hours</strong> Stunden bis: $event</li>";
	}
}
elseif ($days == 0 && $hours == 0 && $minutes > 0) {
// wieviele Minutem zum Termin
if ($minutes == 1) {
	print "<strong>$minutes</strong> Minute bis: $event</li>";
	}
	else {
	print "<strong>$minutes</strong> Minuten bis: $event</li>";
	}
}
elseif ($days > 0) {
// wieviele Tage zum Termin
if ($days == 1) {
	print "<strong>$days</strong> Tag bis: $event</li>";
	}
	else {
	print "<strong>$days</strong> Tage bis: $event</li>";
	}
      }
    }
 }

  }
  else
  {
    echo "<li>".__('No events.','ec3')."</li>\n";
  }
  echo "</ul>\n";
}

/** Addon Countdown */
/** Upcoming Events widget. Made by Marc Metzger Metma */
  function ec3_widget_countd($args)
  {
    extract($args);
    $options = get_option('ec3_widget_countd');
    echo $before_widget . $before_title;
    echo ec3_widget_countd_title($options['title'],'Countdown Events');
    echo $after_title;
      ec3_get_countd_events($options['limit']);

    echo $after_widget;
  }

  function ec3_widget_countd_control()
  {
    $options = $newoptions = get_option('ec3_widget_countd');
    if ( $_POST["ec3_countd_submit"] )
    {
      $newoptions['title'] = strip_tags(stripslashes($_POST["ec3_countd_title"]));
      $newoptions['limit'] = strip_tags(stripslashes($_POST["ec3_countd_limit"]));
    }
    if ( $options != $newoptions )
    {
      $options = $newoptions;
      update_option('ec3_widget_countd', $options);
    }
     

    $title = ec3_widget_countd_title($options['title'],'Countdown Events');
    $limit = $options['limit'];
    
    $ec3_limit_title =
      __("Examples: '5', '5 days', '5d'. To display recent past events, use a negative number: '-5'.");
    ?>
 

    <p>
     <label for="ec3_countd_title">
      <?php _e('Title:'); ?>
      <input class="widefat" id="ec3_countd_title" name="ec3_countd_title"
       type="text" value="<?php echo htmlspecialchars($title,ENT_QUOTES); ?>" />
     </label>
    </p>

    <p>
     <label for="ec3_countd_limit" title="<?php echo $ec3_countd_limit?>">
      <?php _e('Number of events:','ec3'); ?>
      <input class="widefat" style="width: 50px; text-align: center;"
      id="ec3_countd_limit" name="ec3_countd_limit" type="text"
      value="<?php echo $limit? $limit: '5'; ?>" />
     </label>
    </p>

    <p><a href="options-general.php?page=ec3_admin">
      <?php _e('Go to Event Calendar Options','ec3') ?>.</a>
    </p>

    <input type="hidden" name="ec3_countd_submit" value="1" />
    
   

    <?php
  }

  register_sidebar_widget(
    array(__('Countdown Events','ec3'),'widgets'),
    'ec3_widget_countd'
  );
  register_widget_control(
    array(__('Countdown Events','ec3'),'widgets'),
    'ec3_widget_countd_control'
  );  

  
}

add_action('widgets_init', 'ec3_widget_countd_init');

?>